from path import draw_grid
from path import GridWithWeights

from path.astar import a_star_search

from path.dijkstra import dijkstra_search
from path.dijkstra import reconstruct_path


diagram4 = GridWithWeights(10, 10)
diagram4.walls = [(1, 7), (1, 8), (2, 7), (2, 8), (3, 7), (3, 8)]

diagram4.weights = {loc: 5 for loc in [(3, 4), (3, 5), (4, 1), (4, 2),
                                       (4, 3), (4, 4), (4, 5), (4, 6),
                                       (4, 7), (4, 8), (5, 1), (5, 2),
                                       (5, 3), (5, 4), (5, 5), (5, 6),
                                       (5, 7), (5, 8), (6, 2), (6, 3),
                                       (6, 4), (6, 5), (6, 6), (6, 7),
                                       (7, 3), (7, 4), (7, 5)]}

diagram1 = GridWithWeights(8, 6)
diagram1.walls = [(1,1),]


#came_from, cost_so_far = a_star_search(diagram1, (1, 4), (5, 1))
#draw_grid(diagram1, 3, point_to=came_from, start=(1, 4), goal=(7, 8))
#print()
#draw_grid(diagram1, 3, number=cost_so_far, start=(1, 4), goal=(7, 8))


came_from, cost_so_far = dijkstra_search(diagram4, (1, 4), (7, 8))

print came_from
print "\n"
print cost_so_far
print "\n\n"

print reconstruct_path(came_from, start=(1, 4), goal=(7, 8))
#
#draw_grid(diagram4, width=3, point_to=came_from, start=(1, 4), goal=(7, 8))
#print ""
#draw_grid(diagram4, width=3, number=cost_so_far, start=(1, 4), goal=(7, 8))
#print()
#draw_grid(diagram4, width=3, path=reconstruct_path(came_from, start=(1, 4), goal=(7, 8)))
